# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# --with reply_plugin
#	Default: --without
# Missing deps (perl(Reply::Plugin))
# Marked as unstable (cf. lib/Reply/Plugin/TypeTiny.pm)
%bcond_with reply_plugin

Name:		perl-Type-Tiny
Version:	2.006000
Release:	1.0.%{__distinit}%{__distvers}
Summary:	Tiny, yet Moo(se)-compatible type constraint
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		http://typetiny.toby.ink/
Source0:	https://cpan.metacpan.org/modules/by-module/Test/Type-Tiny-%{version}.tar.gz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(CPAN::Meta::Requirements) >= 2.0
BuildRequires:	perl(ExtUtils::MakeMaker) >= 6.17
BuildRequires:	sed
# Module Runtime
BuildRequires:	perl(B)
BuildRequires:	perl(Exporter::Tiny) >= 1.006000
BuildRequires:	perl(List::Util)
BuildRequires:	perl(overload)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(strict)
BuildRequires:	perl(Text::Balanced)
BuildRequires:	perl(utf8)
BuildRequires:	perl(warnings)
# Optional Module Runtime
BuildRequires:	perl(B::Deparse)
BuildRequires:	perl(Carp)
BuildRequires:	perl(Class::XSAccessor) >= 1.17
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(Devel::LexAlias) >= 0.05
BuildRequires:	perl(Devel::StackTrace)
BuildRequires:	perl(mro)
BuildRequires:	perl(namespace::clean)
BuildRequires:	perl(re)
BuildRequires:	perl(Ref::Util::XS) >= 0.100
%{?with_reply_plugin:
BuildRequires:	perl(Reply::Plugin)}
%{?with_reply_plugin:
BuildRequires:	perl(Term::ANSIColor)}
%if 0%{!?perl_bootstrap:1}
%if 0%{?fedora} > 34 || 0%{?rhel} > 8
BuildRequires:	perl(Type::Tiny::XS)
%endif
%endif
# Test Suite
BuildRequires:	perl(Config)
BuildRequires:	perl(constant)
BuildRequires:	perl(Encode)
%if 0%{?fedora} > 21 || 0%{?rhel} > 7
BuildRequires:	perl(experimental)
%endif
BuildRequires:	perl(Exporter::Shiny)
BuildRequires:	perl(lib)
BuildRequires:	perl(Math::BigFloat)
BuildRequires:	perl(Test::Builder)
BuildRequires:	perl(Test::Fatal)
BuildRequires:	perl(Test::More) >= 0.96
BuildRequires:	perl(Test::Requires)
BuildRequires:	perl(threads)
BuildRequires:	perl(Tie::Array)
BuildRequires:	perl(Tie::Scalar)
# Optional Tests
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(Benchmark)
BuildRequires:	perl(Clone)
%if 0%{?fedora} > 35 || 0%{?rhel} > 9
BuildRequires:	perl(Data::Constraint)
%endif
BuildRequires:	perl(Devel::Cover)
BuildRequires:	perl(Devel::Hide)
BuildRequires:	perl(Devel::Refcount)
BuildRequires:	perl(Exporter) >= 5.59
BuildRequires:	perl(feature)
%if 0%{?fedora} > 23 || 0%{?rhel} > 7
BuildRequires:	perl(Function::Parameters) >= 1.0103
%endif
BuildRequires:	perl(IO::File)
BuildRequires:	perl(IO::String)
BuildRequires:	perl(JSON::PP) >= 4.00
BuildRequires:	perl(Lexical::Sub)
%if 0%{?fedora} > 27 || 0%{?rhel} > 7
BuildRequires:	perl(match::simple)
%endif
BuildRequires:	perl(Method::Generate::Accessor)
BuildRequires:	perl(Moo) >= 1.006000
BuildRequires:	perl(Moo::Role)
%if 0%{?fedora} > 32 || 0%{?rhel} > 9
BuildRequires:	perl(MooX::TypeTiny)
%endif
BuildRequires:	perl(Moose) >= 2.1210
BuildRequires:	perl(Moose::Meta::TypeCoercion)
BuildRequires:	perl(Moose::Meta::TypeCoercion::Union)
BuildRequires:	perl(Moose::Meta::TypeConstraint)
BuildRequires:	perl(Moose::Meta::TypeConstraint::Class)
BuildRequires:	perl(Moose::Meta::TypeConstraint::DuckType)
BuildRequires:	perl(Moose::Meta::TypeConstraint::Enum)
BuildRequires:	perl(Moose::Meta::TypeConstraint::Union)
BuildRequires:	perl(Moose::Util::TypeConstraints)
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl(MooseX::Getopt) >= 0.63
%endif
BuildRequires:	perl(MooseX::Types)
%if 0%{?fedora} > 16 || 0%{?rhel} > 7
BuildRequires:	perl(MooseX::Types::Common) >= 0.001004
%endif
BuildRequires:	perl(MooseX::Types::Moose)
BuildRequires:	perl(Mouse) >= 1.000
BuildRequires:	perl(Mouse::Meta::TypeConstraint)
BuildRequires:	perl(Mouse::Util)
BuildRequires:	perl(Mouse::Util::TypeConstraints)
BuildRequires:	perl(MouseX::Types) >= 0.06
%if 0%{?fedora} > 34 || 0%{?rhel} > 9
BuildRequires:	perl(MouseX::Types::Common) >= 0.001000
%endif
BuildRequires:	perl(MouseX::Types::Moose)
BuildRequires:	perl(Object::Accessor) >= 0.30
%if 0%{?fedora} > 33 || 0%{?rhel} > 8
BuildRequires:	perl(Return::Type) >= 0.007
%endif
BuildRequires:	perl(Role::Tiny)
BuildRequires:	perl(Role::Tiny::With)
BuildRequires:	perl(Specio)
BuildRequires:	perl(Storable)
%if 0%{?fedora} > 23 || 0%{?rhel} > 7
BuildRequires:	perl(Sub::Exporter::Lexical) >= 0.092291
%endif
BuildRequires:	perl(Sub::Quote)
BuildRequires:	perl(Test::Deep)
BuildRequires:	perl(Test::LeakTrace)
BuildRequires:	perl(Test::Memory::Cycle)
BuildRequires:	perl(Test::Moose) >= 2.1210
BuildRequires:	perl(Test::Tester) >= 0.109
BuildRequires:	perl(Test::Warnings) >= 0.005
BuildRequires:	perl(Tie::Hash)
%if 0%{?fedora} > 23
BuildRequires:	perl(Types::Path::Tiny)
%endif
%if 0%{?fedora} > 23 || 0%{?rhel} > 7
BuildRequires:	perl(Validation::Class) >= 7.900017
BuildRequires:	perl(Validation::Class::Simple)
%endif
%endif
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(B::Deparse)
Requires:	perl(Carp)
Requires:	perl(Data::Dumper)
Requires:	perl(List::Util)
Requires:	perl(mro)
Requires:	perl(namespace::clean)
Requires:	perl(re)
Requires:	perl(Text::Balanced)
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
Recommends:	perl(Class::XSAccessor) >= 1.17
Recommends:	perl(Devel::LexAlias) >= 0.05
Recommends:	perl(Devel::StackTrace)
Recommends:	perl(Ref::Util::XS) >= 0.100
%else
Requires:	perl(Class::XSAccessor) >= 1.17
Requires:	perl(Devel::LexAlias) >= 0.05
Requires:	perl(Devel::StackTrace)
Requires:	perl(Ref::Util::XS) >= 0.100
%endif
%if 0%{?fedora} > 34 || 0%{?rhel} > 8
Recommends:	perl(Type::Tiny::XS)
%endif
# Sub::Util is preferred to Sub::Name, but isn't always available
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl(Sub::Util)
Requires:	perl(Sub::Util)
%else
BuildRequires:	perl(Sub::Name)
Requires:	perl(Sub::Name)
%endif

Obsoletes:	perl-Type-Tie < 0.015-10
Provides:	perl-Type-Tie = %{version}-%{release}

# Optional Modules not yet available
#TODO: BuildRequires:	perl(Class::InsideOut) >= 1.13
#TODO: BuildRequires:	perl(Class::Plain) >= 0.02 (also needs experimental)
#TODO: BuildRequires:	perl(Kavorka)
#TODO: BuildRequires:	perl(Moops)
#TODO: BuildRequires:	perl(Regexp::Util) >= 0.003
#TODO: BuildRequires:	perl(Switcheroo)
#TODO: BuildRequires:	perl(Types::XSD::Lite)

%description
Type::Tiny is a tiny class for creating Moose-like type constraint objects
that are compatible with Moo, Moose and Mouse.

%package -n perl-Test-TypeTiny
Summary:	Test::TypeTiny module
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif

%description -n perl-Test-TypeTiny
Test::TypeTiny module.

%prep
%setup -q -n Type-Tiny-%{version}

# Remove bundled modules Test::Fatal, Test::Requires and Try::Tiny
rm -rv ./inc/
sed -i -e '/^inc\//d' MANIFEST

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test EXTENDED_TESTING=1

%files
%license COPYRIGHT LICENSE
%doc Changes CONTRIBUTING CREDITS NEWS README
%{perl_vendorlib}/Devel/
%{perl_vendorlib}/Error/
%{perl_vendorlib}/Eval/
%{!?with_reply_plugin:
%exclude }%{perl_vendorlib}/Reply/
%{perl_vendorlib}/Type/
%{perl_vendorlib}/Types/
%{_mandir}/man3/Error::TypeTiny.3*
%{_mandir}/man3/Error::TypeTiny::Assertion.3*
%{_mandir}/man3/Error::TypeTiny::Compilation.3*
%{_mandir}/man3/Error::TypeTiny::WrongNumberOfParameters.3*
%{_mandir}/man3/Eval::TypeTiny.3*
%{_mandir}/man3/Eval::TypeTiny::CodeAccumulator.3*
%{!?with_reply_plugin:
%exclude }%{_mandir}/man3/Reply::Plugin::TypeTiny.3*
%{_mandir}/man3/Type::Coercion.3*
%{_mandir}/man3/Type::Coercion::FromMoose.3*
%{_mandir}/man3/Type::Coercion::Union.3*
%{_mandir}/man3/Type::Library.3*
%{_mandir}/man3/Type::Params.3*
%{_mandir}/man3/Type::Parser.3*
%{_mandir}/man3/Type::Registry.3*
%{_mandir}/man3/Type::Tie.3*
%{_mandir}/man3/Type::Tiny.3*
%{_mandir}/man3/Type::Tiny::_DeclaredType.3*
%{_mandir}/man3/Type::Tiny::Bitfield.3*
%{_mandir}/man3/Type::Tiny::Class.3*
%{_mandir}/man3/Type::Tiny::ConstrainedObject.3*
%{_mandir}/man3/Type::Tiny::Duck.3*
%{_mandir}/man3/Type::Tiny::Enum.3*
%{_mandir}/man3/Type::Tiny::Intersection.3*
%{_mandir}/man3/Type::Tiny::Manual.3*
%{_mandir}/man3/Type::Tiny::Manual::AllTypes.3*
%{_mandir}/man3/Type::Tiny::Manual::Coercions.3*
%{_mandir}/man3/Type::Tiny::Manual::Contributing.3*
%{_mandir}/man3/Type::Tiny::Manual::Installation.3*
%{_mandir}/man3/Type::Tiny::Manual::Libraries.3*
%{_mandir}/man3/Type::Tiny::Manual::NonOO.3*
%{_mandir}/man3/Type::Tiny::Manual::Optimization.3*
%{_mandir}/man3/Type::Tiny::Manual::Params.3*
%{_mandir}/man3/Type::Tiny::Manual::Policies.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithClassTiny.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithMite.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithMoo.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithMoo2.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithMoo3.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithMoose.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithMouse.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithOther.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithTestMore.3*
%{_mandir}/man3/Type::Tiny::Role.3*
%{_mandir}/man3/Type::Tiny::Union.3*
%{_mandir}/man3/Type::Tiny::_HalfOp.3*
%{_mandir}/man3/Type::Utils.3*
%{_mandir}/man3/Types::Common.3*
%{_mandir}/man3/Types::Common::Numeric.3*
%{_mandir}/man3/Types::Common::String.3*
%{_mandir}/man3/Types::Standard.3*
%{_mandir}/man3/Types::TypeTiny.3*

%files -n perl-Test-TypeTiny
%{perl_vendorlib}/Test/
%{_mandir}/man3/Test::TypeTiny.3*

%changelog
* Tue Oct  1 2024 Paul Howarth <paul@city-fan.org> - 2.006000-1.0
- Update to 2.006000
  Bug Fixes:
  - Fix uninitialized warning messages from Error::TypeTiny when processing very
    shallow stack traces
  Documentation:
  - Fixes for various typos (GH#155)
  - Improve documentation for the initialization of the 'coercion' attribute
    for 'Type::Tiny'
  - Fix minor typo in documentation for named parameters in 'Type::Params'
  - Update copyright notices in files to 2024
  Other:
  - Updated: Smartmatch discontinued beginning perl-5.41.3; Type::Tiny will no
    longer attempt to support smartmatch if the Perl version is too high
    (GH#161)
  - Improved initialization of variables when they are tied to a type
    constraint; initialization to explicit values will work even when not tied
    via the 'ttie' wrapper function; if no explicit values are provided, tied
    scalars will be initialized to the type's 'type_default'
    So for example, 'tie( my $title, Str )' will initialize '$title' to the
    empty string instead of undef, and 'tie( my $title, Str, 'Foo' )' will
    initialize the variable to 'Foo' as was already implied by documentation
  - Inlining 'Int' now calls the XS implementation when available (the speed
    improvement is negligible, but it also may result in small memory savings)
    (GH#145)
  - Removed: Support for the ${^TYPE_PARAMS_MULTISIG} global variable has been
    dropped; using this global variable was deprecated in trial version
    1.999_010 and stable version 2.000000, both of which are nearly two years
    old - use ${^_TYPE_PARAMS_MULTISIG} instead

* Mon Sep 16 2024 Paul Howarth <paul@city-fan.org> - 2.004000-7.0
- BR: perl(MouseX::Types::Common)

* Fri Sep  6 2024 Paul Howarth <paul@city-fan.org> - 2.004000-6.0
- Require Sub::Util if available, or Sub::Name
- Add optional test dependencies perl(Data::Constraint) and perl(MooX::TypeTiny)
  where available

* Mon Jul 22 2024 Paul Howarth <paul@city-fan.org> - 2.004000-5.0
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Fri Jun 14 2024 Paul Howarth <paul@city-fan.org> - 2.004000-4.1
- Tie::Scalar and Tie::Array are not optional test requirements

* Fri Jan 26 2024 Paul Howarth <paul@city-fan.org> - 2.004000-4.0
- Re-rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild
  (see https://pagure.io/releng/issue/11888)

* Mon Jan 22 2024 Paul Howarth <paul@city-fan.org> - 2.004000-3.0
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Jul 21 2023 Paul Howarth <paul@city-fan.org> - 2.004000-2.0
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Wed Apr  5 2023 Paul Howarth <paul@city-fan.org> - 2.004000-1.0
- Update to 2.004000
  Documentation
  - Add SYNOPSIS for Type::Tiny::Class
  - Add SYNOPSIS for Type::Tiny::Duck
  - Add SYNOPSIS for Type::Tiny::Enum
  - Add SYNOPSIS for Type::Tiny::Intersection
  - Add SYNOPSIS for Type::Tiny::Role
  - Add SYNOPSIS for Type::Tiny::Union
  - Add documentation and tests for the combination of the 'goto_next' and
    'multiple' options when used with 'signature_for'
  - Add example of 'signature_for' applying a signature to multiple functions
    at once
  - Document changes to 'make_immutable' in Type::Library v2.x (GH#129)
  - Document that the 'BoolLike' type is unstable
  - Minor pod changes to Types::Standard
  Packaging
  - Summarized the change log for versions prior to Type::Tiny 2.000000; if you
    need more information, see the Changes file included with Type::Tiny
    2.002001:
    https://metacpan.org/release/TOBYINK/Type-Tiny-2.002001/source/Changes
  Other
  - Added: Type::Tiny now has an 'exception_class' attribute, allowing a type
    to throw exceptions using a custom class, which should usually be a
    subclass of Error::TypeTiny::Assertion (GH#133)
  - Added: Type::Tiny::Bitfield class (GH#131)
  - Added: Types::TypeTiny::BoolLike type constraint (GH#137)

* Fri Jan 20 2023 Paul Howarth <paul@city-fan.org> - 2.002001-1.0
- Update to 2.002001
  Bug Fixes
  - Bugfix for Type::Tie+Storable issue affecting 32-bit builds of Perl

* Mon Jan  2 2023 Paul Howarth <paul@city-fan.org> - 2.002000-1.0
- Update to 2.002000
  Bug Fixes
  - Avoid uninitialized warnings when creating a union between an Enum type and
    a non-Enum type
  - When Foo is a parameterized StrMatch type, ensure is_Foo always returns a
    single boolean value, even in list context
  Packaging
  - Depend on Exporter::Tiny 1.006000, which offers lexical export support for
    older versions of Perl, provided Lexical::Sub is installed
  Documentation
  - Clearer documentation of Types::TypeTiny::to_TypeTiny
  - Typo fix in Type::Tiny::Manual::UsingWithMoo
  - Update NEWS
  - Update copyright dates to 2023
  Test Suite
  - No longer report Type::Tie version at start of test suite, as Type::Tie is
    now bundled
  - Test 't/20-modules/Type-Tiny-Enum/exporter_lexical.t' will now run on
    older versions of Perl, provided Lexical::Sub is installed
  Other
  - Added: Type::Library now has an undocumented, but tested and hopefully
    stable '_remove_type' method
  - Added: Type::Tiny now has a 'definition_context' attribute/method
    indicating the file and line number where a type constraint was first
    defined
  - The list of packages Type::Tiny considers to be 'internal' has been moved
    from Error::TypeTiny to Type::Tiny
  - Type::Tiny will now mark particular parts of its guts as readonly;
    currently this is mainly used to prevent people pushing to and popping from
    type constraints that overload '@{}'
  - Type::Library will better detect if two types result in functions with the
    same name
  - Type::Tiny::XS will now provide XS implementations of some parameterized
    ArrayLike/HashLike types
  - When importing 'use Type::Library -util', Type::Library will now pass some
    relevant import options to Type::Utils
  - If Type::Params signatures receives multiple unrecognized named arguments,
    the error message now lists them using Type::Utils::english_list() instead
    of just joining them with commas; this means that the error message will
    include 'and' before the last unrecognized named argument (if
    Type::Tiny::AvoidCallbacks is set to true while the signature is compiled,
    the old behaviour will be retained)
  - Type::Params no longer attempts to figure out the maximum number of
    expected arguments to functions that take key-value pairs; this allows
    'yourfunc(y=>1,y=>2)' to behave more intuitively, with the function just
    seeing the second value for 'y', instead of it throwing an exception
    complaining about too many arguments

* Sun Nov 20 2022 Paul Howarth <paul@city-fan.org> - 2.000001-3.0
- Don't BR: perl(Type::Tiny::XS) when bootstrapping

* Thu Nov 17 2022 Paul Howarth <paul@city-fan.org> - 2.000001-2.0
- Use Type::Tiny::XS where available

* Fri Sep 30 2022 Paul Howarth <paul@city-fan.org> - 2.000001-1.0
- Update to 2.000001
  Bug Fixes
  - Avoid uninitialized warnings when creating a union between an Enum type and
    a non-Enum type
  Documentation
  - Clearer documentation of Types::TypeTiny::to_TypeTiny
  Test Suite
  - No longer report Type::Tie version at start of test suite, as Type::Tie is
    now bundled

* Sun Sep 25 2022 Paul Howarth <paul@city-fan.org> - 2.000000-1.1
- Obsolete/Provide perl-Type-Tie, now bundled here

* Fri Sep 23 2022 Paul Howarth <paul@city-fan.org> - 2.000000-1
- Update to 2.000000
  Back Compat
  - If none of a multisig's alternative sigs match the parameter list,
    ${^TYPE_PARAMS_MULTISIG} will explicitly be set to undef, instead of being
    left as-is
  - The Eval::TypeTiny::HAS_LEXICAL_VARS constant no longer exists; it was
    deprecated in Type-Tiny-1.004000 (2018-07-27)
  - More sensible error message trying to import a type constraint using
    -declare outside a type library
  Bug Fixes
  - Types::Common was not correctly handling the -sigs export tag
  - Setting a default for a slurpy parameter in Type::Params now warns and
    ignores the default instead of failing to compile because of a syntax error
  - What was supposed to be a warning for slurpy+default in Type::Params was
    throwing an exception: corrected to be a warning
  Documentation
  - Document usage with Class::Plain
  - Updated Type::Tiny::Manual to cover new features
  - Fix misspelling of 'GitHub' in documentation
  - Updated the SYNOPSIS for Types::Standard and Type::Tiny
  - Improvements to Type::Params documentation
  - Update NEWS
  - Minor documentation clarifications around new constructor methods for
    Type::Tiny subclasses
  - Document in Type::Tie that Type::Tie is implicitly loaded when you tie a
    variable to a Type::Tiny type constraint (it was already documented in the
    manual)
  - Document the Type::Tie::BASE 'type' method
  - Removed stub pod from a bunch of internal modules; they're internal, so
    nobody should be expecting pod
  Packaging
  - Add Class::XSAccessor to Type::Tiny's recommendations
  Other
  - %%Error::TypeTiny::CarpInternal is now an alias for %%Carp::CarpInternal
  - Added: Type::Tiny 'type_default' method
  - Added: Type::Tiny overloads '/'
  - Added: Types::Common module
  - The Type::Params API has had a major overhaul, introducing 'signature' and
    'signature_for' functions; the 'compile', 'compile_named',
    'compile_named_oo', 'validate', 'validate_named', 'wrap_subs', and
    'wrap_methods' functions are now considered the legacy API (there are no
    plans to drop support for the legacy API in the foreseeable future)
  - Updated: dropping support for Perl 5.6.1 (which was released in April
    2001), 5.6.2 (November 2003), and Perl 5.8.0 (July 2002); Type::Tiny now
    requires at least Perl 5.8.1
  - Major simplifications of Type::Library internals
  - Updated: Require Exporter::Tiny 1.004001+ (previously required
    Exporter::Tiny 1.000000)
  - Types::Common now also extends Types::TypeTiny
  - Minor bugfixes and improvements to slurpy handling in Type::Params
  - Added: move two helper subs (set_subname and type_to_coderef) out of
    Type::Library and into Eval::TypeTiny, clean them up, and document them as
    part of the API
  - Added: Type::Tiny now has an 'exportables' method that provides a list of
    functions that the type can export; type libraries now defer to this when
    deciding what they can export
  - Added: Type::Tiny::Class is now an exporter
  - Added: Type::Tiny::Duck is now an exporter
  - Added: Type::Tiny::Enum is now an exporter
  - Added: Type::Tiny::Role is now an exporter
  - Type::Tiny::{Class,Duck,Enum,Role} subclass Exporter::Tiny instead of
    handling exports manually
  - Added: Type::Tiny::Enum has an is_word_safe method that indicates whether
    all values in the enumeration are 'words' (i.e. contain only word
    characters)
  - Added: Word-safe enumerations export constants for each value
  - The NICE_PROTOTYPES constant has been moved from Type::Library to
    Eval::TypeTiny, though a copy of it is still available in Type::Library for
    backwards compatibility
  - The intersection of two Type::Tiny::Enum objects is now a Type::Tiny::Enum
    instead of a Type::Tiny::Intersection
  - The union of two Type::Tiny::Enum objects is now a Type::Tiny::Enum instead
    of a Type::Tiny::Union
  - Type::Params will call default coderefs as a method for signatures where
    method => 1
  - The functionality provided by Type::Params::multisig() is now provided in
    the Type::Params v2 API (and is slightly more functional!)
  - Get the 'multiple' option working with the 'signature_for' function from
    Type::Params
  - Improved test cases and miscellaneous small bugfixes for slurpy parameters
    in Type::Params
  - Minor refactoring, mostly to make things more easily testable
  - Added: Type::Tiny now has an exportables_by_tag method
  - Added: Type::Tiny::_DeclaredType is now a separate module (it was
    previously defined inline in Type/Library.pm)
  - Eval::TypeTiny::type_to_coderef() can now handle being passed undef as a
    type constraint and will create a Type::Tiny::_DeclaredType object to wrap
    instead
  - If a type library has been made immutable, you can no longer add new types
    and coercions to it
  - Type::Params 'signature_for' will now delay most of the signature
    compilation until the function is called for the first time, like
    'wrap_subs'/'wrap_methods' used to do; it still does enough up-front to
    detect some common errors in signatures
  - Various Type::Library clean-ups
  - Added: Types::Common::String now has a DelimitedStr type
  - Improve cache key generation for parameterized types
  - Minor improvements to the default name generator, used to generate the
    display_name for parameterized type constraints
  - Eval::TypeTiny::CodeAccumulator now supports $coderef->compile(alias => 1)
  - If the 'ws' parameter is set to true in parameterized DelimitedStr type
    constraints, leading and trailing whitespace will now be permitted
  - Non-parameterized DelimitedStr now has a coercion from ArrayRef[Str]
  - The ${^TYPE_PARAMS_MULTISIG} magic global variable is now called
    ${^_TYPE_PARAMS_MULTISIG}; the old name will still be supported for at
    least six months after the next stable release
  - Added: Bundle Type::Tie, which was previously in a separate distribution on
    the CPAN
  - Adding a type constraint to a type library will now also add it to the
    library's type registry (even though this registry is unlikely to be used)
  - Rewrite much of Type::Tie to no longer use inside-out objects and avoid a
    dependency on Hash::Util::FieldHash or alternative implementations of
    fieldhashes
  - Type::Parser's internal packages now have version numbers
  - Type::Tie now supports variables being cloned with Clone::clone(); it
    already supported Storable::dclone()
  - Type::Tie will now try to load Class::XSAccessor::Array for a speed-up
  - Using Type::Utils to declare a named type will now automatically add the
    type to the caller's type registry
  - Type::Params signature_for will respect inheritance when looking for
    methods to wrap, when the 'method' option is true
  Test Suite
  - More tests
  - Tests for the 'type_default' of all built-in types
  - Better tests for 'strictness' option in Type::Params
  - Improved tests for slurpy handling in Type::Params
  - The internal module Type::Params::Signature now has some tests of its own
  - Add versions of tests for the new Type::Params v2 API that don't rely on
    Perl 5.20 features
  - More tests for Type::Tiny::{Class,Duck,Enum,Role} exporting
  - Improved test cases; now 100%% coverage on coveralls.io
  - Another test for '-base'
  - Bundle a (renamed) copy of Type::Nano in the test suite for some tests
    combining Type::Nano and Type::Tiny type constraints, and converting
    Type::Nano to Type::Tiny
  - Improved test cases for Type::Tie with an aim at 100%% coverage
  - Test usage with Class::Plain
 
* Thu Sep  1 2022 Paul Howarth <paul@city-fan.org> - 1.016010-1
- Update to 1.016010
  - Fix an uninitialized warning when calling compile_named_oo outside a sub
  - List which versions of Perl Type::Tiny requires in
    Type::Tiny::Manual::Policies

* Sun Aug 28 2022 Paul Howarth <paul@city-fan.org> - 1.016009-1
- Update to 1.016009
  - Parameterizable type constraints have a name generator, which is a coderef
    that generates the names of their parameterized child type constraints;
    the default name generator now strips ASCII control characters (such as
    null, tab, and new line) from names it generates (GH#96)
- Use SPDX-format license tag

* Sun Aug 14 2022 Paul Howarth <paul@city-fan.org> - 1.016008-1
- Update to 1.016008
  - Added: Type::Params now has a 'goto_next' option, which if set to a coderef
    will generate a signature which on success, instead of returning @_, passes
    @_ to the coderef; if 'goto_next' is set to true, the signature instead
    expects to be passed such a coderef as its first argument
  - Eval::TypeTiny::CodeAccumulator now better handles placeholders
  - Type::Params 'wrap_subs' and 'wrap_methods' internally use 'goto_next'

* Fri Aug  5 2022 Paul Howarth <paul@city-fan.org> - 1.016007-1
- Update to 1.016007
  - Added: Type::Params now has a 'strictness' option, which if set to false
   (or certain strings of Perl code that evaluate to false) will skip type
   checks apart from when needed for coercions, skip parameter count checks,
   and skip checks for unknown named parameters; you generally don't want to
   set it to false or indeed set it at all

* Tue Jul 26 2022 Paul Howarth <paul@city-fan.org> - 1.016006-1
- Update to 1.016006
  Documentation:
  - Added a new page to the manual: Type::Tiny::Manual::UsingWithMite
  Other:
  - Type::Tiny now overloads 0+ to return a unique number per type constraint

* Sun Jul 24 2022 Paul Howarth <paul@city-fan.org> - 1.016005-1
- Update to 1.016005
  Bug Fixes:
  - Minor bugfix in Type::Tiny::cmp where in some cases it was returning '0'
    instead of '0E0'; unlikely to affect anything
  Other:
  - Updated: Updated Type::Params benchmarking scripts
  - When Type::Registry/Type::Parser has to create a class or role type
    constraint, use Types::Standard InstanceOf/ConsumerOf instead of creating
    new anonymous Type::Tiny::Class/Type::Tiny::Role constraints

* Sat Jul 23 2022 Paul Howarth <paul@city-fan.org> - 1.016004-1
- Update to 1.016004
  - Added: Type::Params now allows named parameters to have aliases

* Fri Jul 22 2022 Paul Howarth <paul@city-fan.org> - 1.016003-1
- Update to 1.016003
  - Catalyst was relying on the internals of the old slurpy function; next
   release of Catalyst should fix that, but this version of Types::Standard
   introduces a workaround for the issue without going back to implementing
   Slurpy the old way (the Catalyst test suite passes at least!)
 - In most places that accept a Slurpy, happily accept a child of a child
   of a child of Slurpy
 - Rename Type::Params::Coderef to Eval::TypeTiny::CodeAccumulator as it's
   not really Type::Params-specific; add test cases for it and make it part
   of the public API
 - Use Eval::TypeTiny::CodeAccumulator in compile_match_on_type
 - When Type::Tiny's is_subtype_of, etc. methods are called, passing a string
   as a parameter, pay attention to calling package's type registry

* Tue Jul 19 2022 Paul Howarth <paul@city-fan.org> - 1.016002-1
- Update to 1.016002
  Back Compat:
  - The slurpy(Foo) function from Types::Standard has been replaced by a new
    Slurpy parameterized type, so you can use Slurpy[Foo] instead; a slurpy()
    function is still provided for backwards compatibility, but if you were
    relying on the internal detail that this used to return an unblessed
    hashref, this release might break that assumption

* Mon Jul 18 2022 Paul Howarth <paul@city-fan.org> - 1.016001-1
- Update to 1.016001
  - Allow Type::Utils::extends to extend Type::Library::Compiler libraries
  - Allow the add_types method of Type::Registry to consume
    Type::Library::Compiler libraries
  - Improved coercion of Type::Library::Compiler's type constraints to
    Type::Tiny

* Sun Jul 17 2022 Paul Howarth <paul@city-fan.org> - 1.016000-1
- Update to 1.016000
  Back Compat:
  - Type::Params is now smarter at calculating the expected $#_ for functions
    that take named parameters, so it can 'fail early' more often when there
    are extra parameters or missing required parameters; this means you may get
    errors indicating the wrong number of parameters when you were previously
    getting errors indicating particular unrecognized or missing required
    parameters, which may break test suites that were looking for particular
    error messages
  Other:
  - Major refactoring of Type::Params, splitting out signature compilation into
    separate backend OO-modules that Type::Params now acts as a front end for;
    this refactor should make the code easier to work with, add new features
    to, and tweak the performance of
  - Type::Params::Signature now avoids using the word 'return' in its generated
    source code, as MooX::Press was using that as a talisman; also avoid using
    the 'return' keyword to return the final results of the signature check, as
    falling through performs better on older Perls, plus it enables MooX::Press
    to convert the coderef into a do{} block
  - Defaults for Type::Params parameters can now be a reference to a string of
    Perl code (like Mite)
  - Add a clone option to parameters in Type::Params to clone them with
    Storable::dclone(); this is mostly a test of how much easier improving
    Type::Params is since it was refactored

* Tue Jun 28 2022 Paul Howarth <paul@city-fan.org> - 1.014000-1
- Update to 1.014000
  Documentation:
  - Update copyright dates to 2022
  - Various minor documentation improvements
  Test Suite:
  - Eliminate some warnings and other noise from the test suite
  - Rename some directories in the test suite to better reflect their contents
  Other:
  - Added: $Type::Tiny::SafePackage variable
  - Added: Error::TypeTiny now has a 'throw_cb' method that acts like 'throw'
    but takes an initial callback parameter
  - Added: Type::Params 'compile', 'compile_named', and 'compile_named_oo'
    functions now support an 'on_die' callback
  - Eliminate warnings while generating deep explanations for type constraint
    check fails under some circumstances (mostly affects StrMatch when
    Regexp::Util isn't installed)

* Wed Jun  8 2022 Paul Howarth <paul@city-fan.org> - 1.012005-1
- Update to 1.012005
  - Ensure coderefs returned by overload::Method are called with three
    parameters, as passing two parameters can break subs implemented in XS
  - Fix explanation message for NumRange/IntRange
  - Prevent stringification of Error::TypeTiny from clobbering $@
  - Fix typos in documentation for wrap_methods from Type::Params

* Fri Jun  3 2022 Paul Howarth <paul@city-fan.org> - 1.012004-4
- Perl 5.36 rebuild

* Mon Aug  2 2021 Paul Howarth <paul@city-fan.org> - 1.012004-1
- Update to 1.012004
  - Fixed typo in Types::Standard documentation where StrMatch regexp parameter
    didn't use qr// properly
- Fix dist tags for Alma and Rocky Linux

* Mon May 24 2021 Paul Howarth <paul@city-fan.org> - 1.012003-3
- Perl 5.34 rebuild

* Mon May 10 2021 Paul Howarth <paul@city-fan.org> - 1.012003-1
- Update to 1.012003
  - Type::Parser now supports negative hexadecimal integers
  - Fixed typo in POD for Type::Tiny::Enum where the 'closest_match' method was
    documented as being called 'closet_match'

* Mon May  3 2021 Paul Howarth <paul@city-fan.org> - 1.012002-1
- Update to 1.012002
  - Fix precedence error in generated code for Tuples (GH#64)
  - Fix typo in pod for Type::Tiny::Enum (GH#70)
  - Fix testcase for Tuples with slurpy HashRef to pass a literal hashref
    (which should fail) instead of an arrayref (which should also fail, but
    less subtly) (GH#64)
  - Type::Tiny is no longer routinely tested on Perl versions older than 5.8.1
    (https://github.com/tobyink/p5-type-tiny/actions)
  - Type::Parser now supports hexadecimal integers (GH#71)

* Mon Jan 11 2021 Paul Howarth <paul@city-fan.org> - 1.012001-1
- Update to 1.012001
  - Extra test cases to improve coverage
  - Hide warnings in Kavorka integration tests
  - Move issue tracker from RT to GitHub Issues
  - Stop hiding Type::Parser::Token, Type::Parser::TokenStream, and
    Type::Parser::AstBuilder from the CPAN indexer
  - Much code tidying using perltidy and manually
  - When generic validation objects (blessed objects with a 'check' method) are
    converted to native Type::Tiny type constraints, no longer require them to
    provide a 'get_message' method; this allows Type::Tiny to adopt
    Data::Constraint type constraints
- Use %%license unconditionally

* Wed Oct 28 2020 Paul Howarth <paul@city-fan.org> - 1.012000-1
- Update to 1.012000
  - List processing methods (grep, map, etc.)
  - Type::Utils::is() and Type::Utils::assert()
  - Improvements to Types::TypeTiny
  - Type::Params now provides an ArgsObject type
  - ArrayLike and HashLike types now parameterizable
  - Type::Library -extends and -utils flags

* Fri Sep  4 2020 Paul Howarth <paul@city-fan.org> - 1.010006-1
- Update to 1.010006
  - Eliminate recursion warnings when Type::Parser needs to parse complex types
    (CPAN RT#121957)
  - Better handling of coercions for pre-declared types in Type::Library; the
    type objects created before the type was properly defined will now lazily
    attempt to find coercions from the properly defined type once it becomes
    available

* Wed Aug 26 2020 Paul Howarth <paul@city-fan.org> - 1.010005-1
- Update to 1.010005
  - Improvements to $AvoidCallbacks support for
    Type::Tiny::{Class,Role,Duck,Enum,Union,Intersection}, and LaxNum, Ref,
    RegexpRef, FileHandle, Object, Overload, and Tied types from Types::Standard

* Tue Aug 18 2020 Paul Howarth <paul@city-fan.org> - 1.010004-1
- Update to 1.010004
  - Fix XSifying Enum[] where the strings contain certain non-word characters
    - https://github.com/tobyink/p5-type-tiny-xs/pull/12
    - https://github.com/tobyink/p5-type-tiny/pull/59
  - Type::Params compile_named using both the head and named_to_list options
    would cause compilation error (CPAN RT#132419)
  - Work around CPAN RT#121957 by avoiding attempting to XSify Enum type
    constraints with more than 50 possible strings
  - Link to HTTPS version of Type::Tiny web page

* Sun Aug  9 2020 Paul Howarth <paul@city-fan.org> - 1.010003-1
- Update to 1.010003
 - ClassName type constraint should treat empty @ISA as if no @ISA were
   defined, like Type::Tiny::XS (CPAN RT#132583)
 - Fix for Type::Tiny->can called as a class method (GH#57)
 - Fix predeclared types in Type::Library (GH#58)
 - Document some edge cases for Types::Standard Int (CPAN RT#132754)

* Mon Jun 29 2020 Paul Howarth <paul@city-fan.org> - 1.010002-3
- Perl 5.32 rebuild

* Sat May  2 2020 Paul Howarth <paul@city-fan.org> - 1.010002-1
- Update to 1.010002
  - Better bareword handling on Perl < 5.14 (CPAN RT#132455)
  - If Scalar::Util was below 1.18, the LaxNum type from Types::Standard would
    accept blobs as being numbers; this is now fixed (CPAN RT#132426)

* Mon Mar 16 2020 Paul Howarth <paul@city-fan.org> - 1.010001-1
- Update to 1.010001
  - MooX::Pression mentions in documentation now refer to Zydeco
  - Test suite passes in cperl, albeit with warnings

* Thu Feb 20 2020 Paul Howarth <paul@city-fan.org> - 1.010000-1
- Update to 1.010000
  - Subclasses of Moose::Meta::TypeConstraint are now converted to the
    appropriate subclasses of Type::Tiny by Types::TypeTiny::to_TypeTiny,
    instead of always being converted to the base class; this improves inlining
    amongst other things
  - When types are declared by Type::Library's -declare import parameter, the
    temporary subs installed can now generate placeholder type constraints
    that allow the types to be used in recursive type definitions
  - Added: Type::Tiny::Enum now has an 'as_regexp' method
  - In some edge cases, the regexps used by Type::Tiny::Enum will now be
    slightly faster
  - More tests for recursively defined type constraints
  - Added: Type::Params now supports 'head' and 'tail' options for 'compile',
    'compile_named', and 'compile_named_oo'
  - Parameterized 'Ref' type constraint in Types::Standard now checks that its
    parameter is a known Perl ref type
  - Fix importing multiple type libraries into a type registry at once
    (CPAN RT#131744)
  - Type::Params on Perl older than 5.10 now uses its own B::perlstring
    implementation to quote strings instead of using B::cstring
  - Mention MooX::Pression in documentation
  - Fix typo in documentation of 'my_methods'
  - Correct documentation of slurpy with compile_named (CPAN RT#131720)

* Thu Jan 30 2020 Paul Howarth <paul@city-fan.org> - 1.008005-1
- Update to 1.008005
  - Remove some Perl 5.012+ syntax from test suite

* Thu Jan 30 2020 Paul Howarth <paul@city-fan.org> - 1.008004-1
- Update to 1.008004
  - When possible, inject 'package Type::Tiny' in generated inline code that
    has an appropriate lexical scope to insert it into; this will (mostly)
    avoid inline code mistakenly using overridden versions of CORE:: functions
  - to_TypeTiny will now cowardly refuse to inline Moose types if they have
    anything in their inline environment

* Tue Jan 14 2020 Paul Howarth <paul@city-fan.org> - 1.008003-1
- Update to 1.008003
  - Makefile.PL will now bail out on cperl if AUTOMATED_TESTING environment
    variable is set to true
  - Added: Type::Registry can now have a parent registry
  - Update copyright dates to 2020

* Mon Jan 13 2020 Paul Howarth <paul@city-fan.org> - 1.008002-1
- Update to 1.008002
  - Fix bareword errors if certain Type::Tiny subclasses were loaded prior to
    Type::Tiny (CPAN RT#131401)
  - Fix some typos in the documentation
  - Type::Tiny didn't accept string constraints for parameterizable type
    constraints; this was not a documented restriction and didn't seem to serve
    any purpose, so the restriction has been lifted (CPAN RT#131238)

* Sat Dec 28 2019 Paul Howarth <paul@city-fan.org> - 1.008001-1
- Update to 1.008001
  - Types::TypeTiny honours $Type::Tiny::AvoidCallbacks
  - Types::TypeTiny now better mocks Type::Library, offering is_* and assert_*
    functions for export
  - Use improved inline_assert when building the coderef for &{$type}
    overloading

* Wed Dec 11 2019 Paul Howarth <paul@city-fan.org> - 1.008000-1
- Update to 1.008000
  - Type::Tiny has a website: http://typetiny.toby.ink/
  - Resolved all bugs from RT
    - Type::Tiny::Enum now has a 'unique_values' method (CPAN RT#129650)
    - Added Type::Params named_to_list feature (CPAN RT#128337)
  - Completed everything on TODO
  - Rewrite of the manual
  - Lots more test cases (now almost 14,000 test cases total!)
  - wrap_methods/wrap_subs in Type::Params

* Wed Nov 13 2019 Paul Howarth <paul@city-fan.org> - 1.006000-1
- Update to 1.006000
  Bug Fixes
  - Fix spelling in error message for Types::Common::String LowerCaseSimpleStr
    (GH#47)
  Documentation
  - Fix Type::Params documentation error (GH#45)
  - Fix Types::Standard documentation error: incorrect third-party module name
    (GH#46)
  - Minor correction to POD header for Type::Params (GH#43)
  - Types::Standard documentation fix (GH#48)
  - Links to Type::Tiny on GitHub/Travis/AppVeyor/Coveralls in Type::Tiny pod
  Packaging
  - Bump minimum required version of Exporter::Tiny to 1.000000
  - Type::Tiny::XS 0.016 is recommended
  Other
  - Added: Type::Params multisig function now supports custom error messages
    (GH#44)
  - Added: Types::Standard ArrayRef parameterized type can now take a second
    parameter, the minimum array length
  - Added: Type::Library now supports 'of' and 'where' options when importing
    type constraints
  - Added: Type::Params named_to_list feature (CPAN RT#128337)
  - Added: Type::Tiny::Enum now has a 'unique_values' method (CPAN RT#129650)
  - Better implementation of is_subtype_of/is_supertype_of and related
    functions
  - Eval::TypeTiny's API is now considered to be stable
  - Tidy up Type::Tiny namespace a little by fully-referencing some functions
    instead of importing them
  - Tweaks to Type::Tiny and Type::Coercion to avoid unnecessarily loading
    overload.pm and overloading.pm
  - Type::Params signatures with slurpy hashrefs now allow true hashrefs to be
    passed to them
  - Types::TypeTiny::TypeTiny->has_coercion is now true
  - Fix Types::Standard's LazyLoad implementation
  - Don't use Int from Type::Tiny::XS unless version 0.016 is available
    (CPAN RT#130411)
  - Eliminate memory cycles created by coderef overloading in Type::Tiny and
    Type::Coercion (CPAN RT#130823)
  - The 'values' attribute of Type::Tiny::Enum now preserves order
    (CPAN RT#129650)
  Test Suite
  - Improve test coverage

* Wed Oct 23 2019 Paul Howarth <paul@city-fan.org> - 1.004004-6
- Include many more optional modules

* Fri Jul 26 2019 Paul Howarth <paul@city-fan.org> - 1.004004-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Wed Jun  5 2019 Paul Howarth <paul@city-fan.org> - 1.004004-4
- Perl 5.30 rebuild

* Wed Jan  9 2019 Paul Howarth <paul@city-fan.org> - 1.004004-1
- Update to 1.004004
  Bug Fixes 
  - Fix spelling in error message for Types::Common::String LowerCaseSimpleStr
    (GH#47)
  - Depend on Exporter::Tiny 0.040; older versions don't provide all the
    functions Type::Library needs.
  Documentation
  - Fix Type::Params documentation error (GH#45)
  - Fix Types::Standard documentation error: incorrect third-party module name
    (GH#46)

* Wed Aug  1 2018 Paul Howarth <paul@city-fan.org> - 1.004002-1
- Update to 1.004002
  - Types::Standard::FileHandle has a looser definition, more consistent with
    Mouse and Type::Tiny::XS
  - Types::Standard::Bool has a stricter definition, but also has a built-in
    coercion from a very loose definition
  - Type::Params now has 'compile_named_oo'
  - Type::Params supports defaults for missing parameters
  - Types::Common::Numeric includes IntRange and NumRange
  - Types::Common::String includes StrLength
  - Type::Tiny now allows types to be marked as deprecated
  - Improvements to Eval::TypeTiny
  - Various bug fixes
  - Improved test suite
- Switch upstream from search.cpan.org to metacpan.org

* Wed Apr 18 2018 Paul Howarth <paul@city-fan.org> - 1.002002-1
- Update to 1.002002
  Bug Fixes
  - Compatibility with constants and with CV-in-stash optimisation
    (CPAN RT#123408)

* Thu Mar 29 2018 Paul Howarth <paul@city-fan.org> - 1.002001-3
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl

* Sun Jun 25 2017 Paul Howarth <paul@city-fan.org> - 1.002001-2
- Don't pull in dependencies for optional tests when bootstrapping

* Mon Jun 19 2017 Paul Howarth <paul@city-fan.org> - 1.002001-1
- Update to 1.002001
  Test Suite
  - Skip t/30-integration/Moose/native-attribute-traits.t on older Moose
    because Test::Moose is broken
  Packaging
  - Ref::Util::XS 0.100 should be recommended, not 0.200 (which doesn't exist
    yet) (CPAN RT#121981)

* Thu Jun  1 2017 Paul Howarth <paul@city-fan.org> - 1.002000-1
- Update to 1.002000
  Back Compat
  - RegexpRef now accepts blessed objects if $object->isa('Regexp') returns
    true
  Bug Fixes
  - Fix for Type::Registry::DWIM (CPAN RT#98458)
  - Fix issues with coercions and native attribute traits with some oldish
    versions of Moose on oldish versions of Perl (CPAN RT#98159)
  - Fix short-circuiting optimizations for parameterized HashRef, ArrayRef,
    ScalarRef and Map type constraints (CPAN RT#99312)
  - Inlined version of Types::Standard::Int should check that the value is not
    a reference
  - Attempting ArrayRef[Int, Int] or similar now throws an exception
    (CPAN RT#105299)
  - 02-api.t should check version of Moose available (GH#20)
  - 20-unit/Type-Utils/warnings.t should check version of Test::Warnings
    (GH#21)
  - Fix minor typos in documentation for Types::Standard (GH#30)
  - Fix variable name typo in documentation for Type::Params (GH#37)
  - Localize $SIG{__DIE__} in Type::Registry (CPAN RT#100780)
  - Type::Params should make sure Type::Utils is loaded before calling
    english_list()
  - Type constraints like Tuple[Int] shouldn't report they have a coercion if
    Int doesn't have a coercion
  - Fixed crazy amount of UTF-8 warnings from Type::Params on Perl 5.6.x and
    Perl 5.8.x (CPAN RT#101582, GH#16)
  - Fix HashRef[Str]|Undef|Str parsing on Perl < 5.14 (CPAN RT#121764)
  Documentation
  - Updated NEWS file
  - Updated TODO file
  - Updates to Type::Tiny::Manual::UsingWithMoose,
    Type::Tiny::Manual::UsingWithMoo, and Type::Tiny::Manual::UsingWithMouse
  - Comparison of Type::Params with new(ish) CPAN module
    Params::ValidationCompiler
  - Show example of how to set defaults for parameters with Type::Params
  - Rearrange the examples directory in the distribution
  - Include page-numbers.pl example
  Test Suite
  - Make some of the test case skip_all bits more ambitious; test older
    versions of Moose and Moo than we were testing before
  - Fix annoying warning message in test suite with recent versions of
    Exporter::Tiny
  - Bundle a test case for GH#14
  - t/00-begin.t will now work around ANDK's apparently broken XS testing
    environment
  Other
  - Added: Type::Params now provides 'compile_named' and 'validate_named'
    functions, which do the same thing as 'compile' and 'validate' but are
    better for named arguments
  - Updated: If the shiny new core Sub::Util is available, use it instead of
    Sub::Name (the former is smaller)
  - Updated: Want Type::Tiny::XS 0.011
  - 'Type::Utils::dwim_type' now allows more control over fallback behaviours
  - Lazy-load Text::Balanced in Type::Parser (many parses don't even need it)
  - Lazy-load Type::Tiny::Union in Type::Params
  - Make equals/is_a_type_of/is_subtype_of/is_supertype_of in Type::Tiny::Union
    work more like Moose::Meta::TypeConstraint::Union
  - Improved error location reporting for Moo (GH#35)
  - Updated: NumericCode now coerces from strings with whitespace in them, like
    MooseX::Types::Common::Numeric (GH#22)
  - Allow Type::Tiny's 'constraint' parameter to be a string of Perl code.
  - Added: Type::Params' 'multisig' function now sets a variable
    '${^TYPE_PARAMS_MULTISIG}' to indicate which signature succeeded
  - Optimization of Type::Params positional parameter checking for simple cases
    with no slurpy parameter and no coercions
  - Optimizations for Tuple and StrMatch type constraints from Types::Standard
  - Added: Named parameter validation benchmarking script
  - Rewrite some benchmarking scripts to use Benchmark::Featureset::ParamCheck
  - Use Ref::Util::XS (if it's installed) to speed up certain type checks
  - Added: Types::Standard now has a CycleTuple type
  - StrMatch will use Regexp::Util (if available) to inline regular expressions
    more sensibly
  - Include trailing line break at the end of stringified version of some
    exceptions
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - Drop workaround for building with Test::More < 0.96
  - BR: perl(Test::Warnings) unconditionally

* Tue Jan 31 2017 Paul Howarth <paul@city-fan.org> - 1.000006-1
- Update to 1.000006
  - Fix escaping within q{...} in a test case (CPAN RT#114386)

* Mon Jan  9 2017 Paul Howarth <paul@city-fan.org> - 1.000005-8
- Test::Warnings now available back to F-9

* Fri Oct 14 2016 Paul Howarth <paul@city-fan.org> - 1.000005-7
- BR: perl-generators where available
- Simplify find command using -delete
- Re-enable use of Devel::Cover for all builds

* Wed Jul  1 2015 Paul Howarth <paul@city-fan.org> - 1.000005-2
- Avoid use of Devel::Cover with Perl 5.22 onwards for now
  (https://github.com/pjcj/Devel--Cover/issues/126)

* Sun Oct 26 2014 Paul Howarth <paul@city-fan.org> - 1.000005-1
- Update to 1.000005
  - Fix short-circuiting optimizations for parameterized HashRef, ArrayRef,
    ScalarRef and Map type constraints (CPAN RT#99312)
  - Fix annoying warning message in test suite with recent versions of
    Exporter::Tiny

* Thu Oct  2 2014 Paul Howarth <paul@city-fan.org> - 1.000004-3
- Import from Fedora

* Thu Sep 04 2014 Jitka Plesnikova <jplesnik@redhat.com> - 1.000004-2
- Perl 5.20 rebuild

* Thu Sep 04 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000004-1
- Upstream update

* Mon Sep 01 2014 Jitka Plesnikova <jplesnik@redhat.com> - 1.000003-2
- Perl 5.20 rebuild

* Sun Aug 31 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000003-1
- Upstream update

* Fri Aug 22 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000002-1
- Upstream update
- Update deps

* Mon Aug 18 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000000-1
- Upstream update

* Thu Jul 24 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 0.046-1
- Upstream update

* Mon Jun 23 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 0.044-1
- Upstream update
- Spec file cosmetics
- BR: perl(Test::Moose), perl(MooseX::Getopt)

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.042-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Tue Apr 08 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 0.042-1
- Upstream update
- Split out perl(Test::TypeTiny) to avoid deps on perl(Test::*)

* Fri Mar 21 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 0.040-1
- Initial Fedora package
